'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.clonedeep');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ThemeOverride = function (_Component) {
  _inherits(ThemeOverride, _Component);

  function ThemeOverride() {
    _classCallCheck(this, ThemeOverride);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  ThemeOverride.prototype.overrideTheme = function overrideTheme(contextTheme, overrideWith) {
    var overrideTheme = overrideWith instanceof Function ? overrideWith(contextTheme) : overrideWith;

    var newTheme = (0, _lodash4.default)(contextTheme);
    return (0, _lodash2.default)(newTheme, overrideTheme);
  };

  ThemeOverride.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        children = _props.children,
        overrideWith = _props.overrideWith;

    return _react2.default.createElement(
      _styledComponents.ThemeProvider,
      {
        theme: function theme(contextTheme) {
          return _this2.overrideTheme(contextTheme, overrideWith);
        }
      },
      _react2.default.createElement(
        _react.Fragment,
        null,
        children
      )
    );
  };

  return ThemeOverride;
}(_react.Component);

exports.default = ThemeOverride;
module.exports = exports['default'];